 MEMBER

 include('c:\apps\winapi.clw'),ONCE

 MAP
   MODULE('win%S%.lib')
     CreateFile(*LPCSTR,DWORD,DWORD,LPVOID,DWORD,DWORD,HANDLE),HANDLE,PASCAL,RAW,NAME('CreateFileA')
     WriteFile(HANDLE,LPCVOID,DWORD,*DWORD,LPVOID),BOOL,PASCAL,RAW
     CloseHandle(HANDLE),BOOL,PASCAL
     GetLastError(),DWORD,PASCAL
     GetObject(HGDIOBJ,SIGNED,LPVOID),SIGNED,PASCAL,RAW,NAME('GetObjectA')
     GetDIBits(HDC,HBITMAP,WORD,WORD,LPVOID,*BITMAPINFO,WORD),SIGNED,PASCAL,RAW
     BitBlt(HDC, SIGNED, SIGNED, SIGNED, SIGNED, HDC, SIGNED, SIGNED, DWORD),BOOL,PASCAL
     CreateCompatibleBitmap(HDC, SIGNED, SIGNED),HBITMAP,PASCAL
     GlobalAlloc(UNSIGNED uFlags,DWORD uBytes),HGLOBAL,PASCAL
     GlobalFree(HGLOBAL),HGLOBAL,PASCAL
     GetDC(HWND),HDC,PASCAL
     ReleaseDC(HWND, HDC),SIGNED,PASCAL
     DeleteDC(HDC),BOOL,PASCAL
     CreateCompatibleDC(HDC),HDC,PASCAL
     SelectObject(HDC,HGDIOBJ),HGDIOBJ,PASCAL
     DeleteObject(HGDIOBJ),BOOL,PASCAL
   END
 END

 include('c:\apps\class\bmpclass.inc'),ONCE

!-----------------------------------------------------------------------------------------------
! NOTE: if multiple instances of this class are used, make sure to call the Kill() method
! before using any of the other instances.....pbmi are shared globally !!!...

pbmi                    &BITMAPINFO

!-----------------------------------------------------------------------------------------------
GENERIC_READ            EQUATE(80000000H)
GENERIC_WRITE           EQUATE(40000000H)
FILE_ATTRIBUTE_NORMAL   EQUATE(00000080H)
CREATE_ALWAYS           EQUATE(2)
INVALID_HANDLE_VALUE    EQUATE(-1)
MAXWRITE                EQUATE(256)
SRCCOPY                 EQUATE(00CC0020h)

GMEM_FIXED              EQUATE(0000h)
LMEM_FIXED              EQUATE(0000h) ! Allocates fixed memory.
LMEM_ZEROINIT           EQUATE(0040h) ! Initializes memory contents to zero.
LPTR                    EQUATE(LMEM_FIXED + LMEM_ZEROINIT)

DIB_RGB_COLORS          EQUATE(0)
DIB_PAL_COLORS          EQUATE(1)

BI_RGB                  EQUATE(0)   ! An uncompressed format.
BI_RLE4                 EQUATE(2)   ! A run-length encoded (RLE) format for bitmaps with 8 bits per pixel.
BI_RLE8                 EQUATE(1)   ! An RLE format for bitmaps with 4 bits per pixel.
BI_BITFIELDS            EQUATE(3)   ! Specifies that the bitmap is not compressed and that the color table consists of three doubleword color masks that specify the red, green, and blue components, respectively, of each pixel. This is valid when used with 16- and 32-bits-per-pixel bitmaps.

!===============================================================================================
BmpClass.Construct          PROCEDURE()
 CODE

!===============================================================================================
BmpClass.Destruct           PROCEDURE()
 CODE
 self.Kill()

!===============================================================================================
BmpClass.CaptureWindow      PROCEDURE(xobj,xfile)
nWidth          Long
nHeight         Long
 CODE
 CLEAR(self.ErrCode)
 CLEAR(self.ErrText)

 IF CLIP(xfile) = ''
   self.ErrorHandler('Invalid Filename')
   RETURN 0
 END
 self.FileName = xfile

 self.H_WND = xobj{PROP:handle}
 self.H_DC  = GetDC(self.H_WND)
 GETPOSITION(xobj,,,nWidth,nHeight)

 self.H_BITMAP = CreateCompatibleBitmap(self.H_DC,nWidth,nHeight)

 self.M_DC = CreateCompatibleDC(self.H_DC)

 IF ~SelectObject(self.M_DC,self.H_BITMAP)
   self.ErrorHandler('Select Object')
   GOTO EXIT_CAPTURE:
 END

 IF ~BitBlt(self.M_DC, 0, 0, nWidth, nHeight,self.H_DC, 0, 0, SRCCOPY)
   self.ErrorHandler('Bit Blt')
   GOTO EXIT_CAPTURE:
 END

 IF ~self.CreateBitmapInfo(self.H_BITMAP)
   GOTO EXIT_CAPTURE:
 END

 IF ~self.CreateBitmapFile(self.H_BITMAP,self.M_DC)
   GOTO EXIT_CAPTURE:
 END

EXIT_CAPTURE:
 self.Kill()

 IF ~self.ErrCode
   RETURN True
 ELSE
   RETURN False
 END

!===============================================================================================
BmpClass.Kill               PROCEDURE()
 CODE
 IF NOT pbmi &= NULL
   IF GlobalFree(pbmi) <> 0
      self.ErrorHandler('Global Free (pbmi)')
   END
   pbmi &= NULL
 END

 IF self.H_DC
   IF ~ReleaseDC(self.H_WND,self.H_DC)
!     self.ErrorHandler('ReleaseDC')
   END
   CLEAR(self.H_DC)
 END

 IF self.M_DC
   IF ~DeleteDC(self.M_DC)
     self.ErrorHandler('Delete DC')
   END
   CLEAR(self.M_DC)
 END

 IF self.H_BITMAP
   IF ~DeleteObject(self.H_BITMAP)
     ! If the given handle is not valid or is currently selected into a device context (DC),
     ! the return value is FALSE.
     self.ErrorHandler('Delete Object')
   END
   CLEAR(self.H_BITMAP)
 END

!===============================================================================================
BmpClass.CreateBitmapInfo   PROCEDURE(HBITMAP hBmp)
bmp             LIKE(BITMAP)
cClrBits        WORD
 CODE

 ! Retrieve the bitmap's color format, width, and height.
 IF ~GetObject(hBmp,size(bmp),address(bmp))
   self.ErrorHandler('Get Object')
   RETURN 0
 END
 
 ! Convert the color format to a count of bits.
 cClrBits = bmp.bmPlanes * bmp.bmBitsPixel
 
 IF cClrBits = 1
    cClrBits = 1
 ELSIF cClrBits <= 4
    cClrBits = 4
 ELSIF cClrBits <= 8
    cClrBits = 8
 ELSIF cClrBits <= 16
    cClrBits = 16
 ELSIF cClrBits <= 24
    cClrBits = 24
 ELSE
    cClrBits = 32
 END

 ! Allocate memory for the BITMAPINFO structure. (This structure
 ! contains a BITMAPINFOHEADER structure and an array of RGBQUAD data structures.

 IF cClrBits <> 24
   pbmi &= GlobalAlloc(LPTR, size(BITMAPINFOHEADER) + size(RGBQUAD) * (2^cClrBits))
 ELSE
   ! There is no RGBQUAD array for the 24-bit-per-pixel format.
   pbmi &= GlobalAlloc(LPTR, size(BITMAPINFOHEADER))
 END

 IF pbmi &= NULL
   self.ErrorHandler('Global Alloc (pbmi)')
   RETURN 0
 END

 ! Initialize the fields in the BITMAPINFO structure.
 pbmi.bmiHeader.biSize  = size(BITMAPINFOHEADER)
 pbmi.bmiHeader.biWidth = bmp.bmWidth

 pbmi.bmiHeader.biHeight   = bmp.bmHeight
 pbmi.bmiHeader.biPlanes   = bmp.bmPlanes
 pbmi.bmiHeader.biBitCount = bmp.bmBitsPixel
 IF cClrBits < 24
   pbmi.bmiHeader.biClrUsed = 2^cClrBits
 END

 ! If the bitmap is not compressed, set the BI_RGB flag.
 pbmi.bmiHeader.biCompression = BI_RGB

 ! Compute the number of bytes in the array of color indices and store the result in biSizeImage.
      
 pbmi.bmiHeader.biSizeImage = (pbmi.bmiHeader.biWidth + 7) / 8 * pbmi.bmiHeader.biHeight * cClrBits
 
 ! Set biClrImportant to 0, indicating that all of the device colors are important.
      
 pbmi.bmiHeader.biClrImportant = 0

 RETURN True

!===============================================================================================
! The following example code defines a function that initializes the remaining structures,
! retrieves the array of palette indices, opens the file, copies the data, and closes the file.
BmpClass.CreateBitmapFile   PROCEDURE(HBITMAP hBmp, HDC hDC)
hfile           HANDLE                      ! file handle
hdr             LIKE(BITMAPFILEHEADER)      ! bitmap file-header
pbih            &BITMAPINFOHEADER           ! bitmap info-header
lpBuff          LPVOID                      ! memory pointer
dwTmp           DWORD                       ! -> bytes written
dwTotal         DWORD                       ! total bytes to write
 CODE
 
 pbih  &= pbmi.bmiHeader
 lpBuff = GlobalAlloc(GMEM_FIXED, pbih.biSizeImage)
 IF ~lpBuff
   self.ErrorHandler('Global Alloc (lpBuff)')
   GOTO EXIT_FILE:
 END
 
 ! Retrieve the color table (RGBQUAD array) and the bits
 ! (array of palette indices) from the DIB.

 IF ~GetDIBits(hDC, hBmp, 0, pbih.biHeight, lpBuff, pbmi, DIB_RGB_COLORS)
   self.ErrorHandler('Get DIBits')
   GOTO EXIT_FILE:
 END

 ! Create the .BMP file.
 
 hfile = CreateFile(self.FileName,GENERIC_READ+GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0)
 
 IF ~hfile OR hfile = INVALID_HANDLE_VALUE
   self.ErrorHandler('Create File')
   GOTO EXIT_FILE:
 END
 
 hdr.bfType = 04d42h        ! 42h = "B" 4dh = "M"
 
 ! Compute the size of the entire file.

 hdr.bfSize = size(BITMAPFILEHEADER) + pbih.biSize + pbih.biClrUsed * size(RGBQUAD) + pbih.biSizeImage
 
 hdr.bfReserved1 = 0
 hdr.bfReserved2 = 0
 
 ! Compute the offset to the array of color indices.
 
 hdr.bfOffBits = size(BITMAPFILEHEADER) + pbih.biSize + (pbih.biClrUsed * size(RGBQUAD))
 
 ! Copy the BITMAPFILEHEADER into the .BMP file.

 IF ~WriteFile(hfile, address(hdr), size(hdr), dwTmp, 0)
   self.ErrorHandler('Write Header')
   GOTO EXIT_FILE:
 END
 
 ! Copy the BITMAPINFOHEADER and RGBQUAD array into the file.
 dwTotal = size(BITMAPINFOHEADER) + (pbih.biClrUsed * size(RGBQUAD))

 IF ~self.WriteBuffer(hfile, address(pbmi.bmiHeader), dwTotal)
   self.ErrorHandler('Write RGB')
   GOTO EXIT_FILE:
 END
 
 ! Copy the array of color indices into the .BMP file.
 dwTotal = pbih.biSizeImage

 IF ~self.WriteBuffer(hfile, lpBuff, dwTotal)
   self.ErrorHandler('Write Indices')
   GOTO EXIT_FILE:
 END

EXIT_FILE:
 pbih &= NULL

 IF hfile
   ! Close the .BMP file.
   IF ~CloseHandle(hfile)
     self.ErrorHandler('Close Handle')
   END
 END

 ! Free memory.
 IF lpBuff
   IF GlobalFree(lpBuff) <> 0
     self.ErrorHandler('Global Free (lpBuff)')
   END
 END

 IF ~self.ErrCode
   RETURN True
 ELSE
   RETURN False
 END

!===============================================================================================
BmpClass.WriteBuffer        PROCEDURE(xfile,xbuff,xtotal)
dwTmp           DWORD       ! -> bytes written
 CODE

 LOOP WHILE xtotal > MAXWRITE
   IF ~WriteFile(xfile, xbuff, MAXWRITE, dwTmp, 0)
      self.ErrorHandler('Write Buffer Loop')
      RETURN 0
   END
   xtotal -= MAXWRITE
   xbuff  += MAXWRITE
 END

 IF ~WriteFile(xfile, xbuff, xtotal, dwTmp, 0)
    self.ErrorHandler('Write Buffer Last')
    RETURN 0
 END

 RETURN True

!===============================================================================================
BmpClass.ErrorHandler       PROCEDURE(String xerr)
 CODE
 self.ErrCode = GetLastError()
 self.ErrText = xerr

 IF ~self.ErrCode
   ! something failed...force error...
   self.ErrCode = -1
 END
