
 OMIT('_EndOfInclude_', _BMPCLASS_)

_BMPCLASS_            EQUATE (1)

BITMAPINFOHEADER        GROUP,TYPE
biSize                    DWORD     ! Specifies the number of bytes required by the structure.
biWidth                   LONG      ! Specifies the width of the bitmap, in pixels.
biHeight                  LONG      ! Specifies the height of the bitmap, in pixels. If biHeight is positive, the bitmap is a bottom-up DIB and its origin is the lower left corner. If biHeight is negative, the bitmap is a top-down DIB and its origin is the upper left corner.
biPlanes                  WORD      ! Specifies the number of planes for the target device. This value must be set to 1.
biBitCount                WORD      ! Specifies the number of bits per pixel. This value must be 1, 4, 8, 16, 24, or 32.
biCompression             DWORD     ! Specifies the type of compression for a compressed bottom-up bitmap (top-down DIBs cannot be compressed).
biSizeImage               DWORD     ! Specifies the size, in bytes, of the image. This may be set to 0 for BI_RGB bitmaps.
biXPelsPerMeter           LONG      ! Specifies the horizontal resolution, in pixels per meter, of the target device for the bitmap. An application can use this value to select a bitmap from a resource group that best matches the characteristics of the current device.
biYPelsPerMeter           LONG      ! Specifies the vertical resolution, in pixels per meter, of the target device for the bitmap.
biClrUsed                 DWORD     ! Specifies the number of color indices in the color table that are actually used by the bitmap.
biClrImportant            DWORD     ! Specifies the number of color indices that are considered important for displaying the bitmap. If this value is zero, all colors are important.
                        END
BITMAPFILEHEADER        GROUP,TYPE
bfType                    WORD      ! Specifies the file type. It must be BM.
bfSize                    DWORD     ! Specifies the size, in bytes, of the bitmap file.
bfReserved1               WORD      ! Reserved; must be zero.
bfReserved2               WORD      ! Reserved; must be zero.
bfOffBits                 DWORD     ! Specifies the offset, in bytes, from the BITMAPFILEHEADER structure to the bitmap bits.
                        END
RGBQUAD                 GROUP,TYPE
rgbBlue                   BYTE      ! Specifies the intensity of blue in the color.
rgbGreen                  BYTE      ! Specifies the intensity of green in the color.
rgbRed                    BYTE      ! Specifies the intensity of red in the color.
rgbReserved               BYTE      ! Reserved; must be zero.
                        END
BITMAP                  GROUP,TYPE
bmType                    LONG      ! Specifies the bitmap type. This member must be zero.
bmWidth                   LONG      ! Specifies the width, in pixels, of the bitmap. The width must be greater than zero.
bmHeight                  LONG      ! Specifies the height, in pixels, of the bitmap. The height must be greater than zero.
bmWidthBytes              LONG      ! Specifies the number of bytes in each scan line. This value must be divisible by 2, because Windows assumes that the bit values of a bitmap form an array that is word aligned.
bmPlanes                  WORD      ! Specifies the count of color planes.
bmBitsPixel               WORD      ! Specifies the number of bits required to indicate the color of a pixel.
bmBits                    LPVOID    ! Points to the location of the bit values for the bitmap. The bmBits member must be a long pointer to an array of character (1-byte) values.
                        END
BITMAPINFO              GROUP,TYPE
bmiHeader                 LIKE(BITMAPINFOHEADER)
bmiColors                 LIKE(RGBQUAD)             ! rgb array...
                        END

!===============================================================================================
BmpClass              CLASS,TYPE,MODULE('c:\apps\class\bmpclass.clw'),LINK('c:\apps\class\bmpclass.clw')
H_WND                   HWND,Private            ! window or object handle...
H_DC                    HDC,Private             ! window or object device context...
M_DC                    HDC,Private             ! memory device context...
H_BITMAP                HBITMAP,Private         ! bitmap handle...
FileName                CString(260)            ! bitmap filename...
ErrCode                 DWORD                   ! last error code...
ErrText                 CString(80)             ! last error description...

Construct               PROCEDURE()
Destruct                PROCEDURE()

Kill                    PROCEDURE()

CaptureWindow           PROCEDURE(Long xobj,String xfile),Byte,Proc

CreateBitmapInfo        PROCEDURE(HBITMAP hBmp),Byte,Private
CreateBitmapFile        PROCEDURE(HBITMAP hBmp, HDC hDC),Byte,Private
WriteBuffer             PROCEDURE(HANDLE xfile, LPCVOID xbuff, DWORD xtotal),Byte,Private
ErrorHandler            PROCEDURE(String xerr),Private
                      END

_EndOfInclude_
